diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemBucket.java b/game/core/src/main/java/net/minecraft/core/item/ItemBucket.java
index 1ff425c4e..252832a64 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemBucket.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemBucket.java
@@ -12,81 +12,81 @@ import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
-public class ItemBucket extends Item
-{
-	private final @Nullable Block<?> blockToPlace;
-    public ItemBucket(@NotNull String name, @NotNull String namespaceId, int id, @Nullable Block<?> blockToPlace)
-    {
+public class ItemBucket extends Item {
+    private final @Nullable Block<?> blockToPlace;
+
+    public ItemBucket(@NotNull String name, @NotNull String namespaceId, int id, @Nullable Block<?> blockToPlace) {
         super(name, namespaceId, id);
         this.maxStackSize = 1;
         this.blockToPlace = blockToPlace;
     }
 
     @Override
-	public @Nullable ItemStack onUse(@NotNull ItemStack selfStack, @NotNull World world, @NotNull Player player) {
-		if(this.blockToPlace == null) {
-			// Milk
-			return new ItemStack(Items.BUCKET);
-		}
+    public @Nullable ItemStack onUse(@NotNull ItemStack selfStack, @NotNull World world, @NotNull Player player) {
+        if (this.blockToPlace == null) {
+            // Milk
+            return new ItemStack(Items.BUCKET);
+        }
+
+        double reachDistance = player.getGamemode().getBlockReachDistance();
+        HitResult rayCast = player.rayCast(reachDistance, 1f, false, false, false);
+
+        if (!(rayCast instanceof HitResult.Tile hitTile)) {
+            return selfStack;
+        }
+
+        TilePos rayCastPos = new TilePos(hitTile.tilePos);
+        if (!world.canMineBlock(player, rayCastPos)) {
+            return selfStack;
+        }
+
+        Block<?> block = world.getBlock(rayCastPos);
+        if (block != null && !block.hasTag(BlockTags.PLACE_OVERWRITES) && !block.hasTag(BlockTags.BROKEN_BY_FLUIDS)) {
+            Side side = hitTile.side;
+            rayCastPos.x += side.getOffsetX();
+            rayCastPos.y += side.getOffsetY();
+            rayCastPos.z += side.getOffsetZ();
+        }
 
-		double reachDistance = player.getGamemode().getBlockReachDistance();
-		HitResult rayCast = player.rayCast(reachDistance, 1f, false, false, false);
-		
-		if(!(rayCast instanceof HitResult.Tile hitTile)) {
-			return selfStack;
-		}
+        if (rayCastPos.y < 0 || rayCastPos.y >= world.getHeightBlocks()) {
+            return selfStack;
+        }
 
-		TilePos rayCastPos = new TilePos(hitTile.tilePos);
-		if(!world.canMineBlock(player, rayCastPos)) {
-			return selfStack;
-		}
-		
-		Block<?> block = world.getBlock(rayCastPos);
-		if(block != null && !block.hasTag(BlockTags.PLACE_OVERWRITES) && !block.hasTag(BlockTags.BROKEN_BY_FLUIDS)) {
-			Side side = hitTile.side;
-			rayCastPos.x += side.getOffsetX();
-			rayCastPos.y += side.getOffsetY();
-			rayCastPos.z += side.getOffsetZ();
-		}
-		
-		if(rayCastPos.y < 0 || rayCastPos.y >= world.getHeightBlocks()) {
-			return selfStack;
-		}
-		
-		if(world.isAirBlock(rayCastPos) || !world.getBlockMaterial(rayCastPos).isSolid()) {
+        if (world.isAirBlock(rayCastPos) || !world.getBlockMaterial(rayCastPos).isSolid()) {
             if (this.blockToPlace == Blocks.FLUID_WATER_FLOWING) {
                 world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, rayCastPos.x + 0.5F, rayCastPos.y + 0.5F, rayCastPos.z + 0.5F, "liquid.splash", 0.5f, 1.0f);
             }
             player.swingItem();
             Block<?> block1 = world.getBlock(rayCastPos);
-            if(block1 != null) {
+            if (block1 != null) {
                 block1.dropWithCause(world, EnumDropCause.WORLD, rayCastPos, world.getBlockData(rayCastPos), null, null);
             }
             world.setBlockIdDataNotify(rayCastPos, this.blockToPlace.id(), 0);
-            if(player.getGamemode().consumeBlocks()) {
-				return new ItemStack(Items.BUCKET);
-			}
-		}
+            if (player.getGamemode().consumeBlocks()) {
+                return new ItemStack(Items.BUCKET);
+            }
+        }
 
-		return selfStack;
-	}
+        return selfStack;
+    }
 
-	@Override
-	public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePos blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
-		if (this.blockToPlace == null) {
-			selfStack.itemID = Items.BUCKET.id;
-			return;
-		}
-		TilePos posAhead = blockPos.add(direction);
-		Block<?> b = world.getBlock(posAhead);
-		if (b == null || BlockTags.PLACE_OVERWRITES.appliesTo(b) || BlockTags.BROKEN_BY_FLUIDS.appliesTo(b)) {
-			world.setBlockIdNotify(posAhead, this.blockToPlace.id());
-			selfStack.itemID = Items.BUCKET.id;
-		}
-	}
+    @Override
+    public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
+        if (this.blockToPlace == null) {
+            selfStack.itemID = Items.BUCKET.id;
+            return;
+        }
+        TilePos posAhead = blockPos.add(direction, new TilePos());
+        Block<?> b = world.getBlock(posAhead);
+        if (b == null || BlockTags.PLACE_OVERWRITES.appliesTo(b) || BlockTags.BROKEN_BY_FLUIDS.appliesTo(b)) {
+            world.setBlockIdNotify(posAhead, this.blockToPlace.id());
+            selfStack.itemID = Items.BUCKET.id;
+        }
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemBucketEmpty.java b/game/core/src/main/java/net/minecraft/core/item/ItemBucketEmpty.java
index ad9f12dfc..c48450322 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemBucketEmpty.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemBucketEmpty.java
@@ -1,16 +1,18 @@
 package net.minecraft.core.item;
 
 import net.minecraft.core.block.entity.TileEntityActivator;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.entity.animal.MobCow;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.util.helper.Direction;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.world.World;
-import net.minecraft.core.block.material.Material;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
 import java.util.List;
 import java.util.Random;
@@ -27,19 +29,19 @@ public class ItemBucketEmpty extends Item {
         double reachDistance = player.getGamemode().getBlockReachDistance();
         HitResult hitResult = player.rayCast(reachDistance, 1f, true, false, false);
 
-        if(hitResult == null) {
+        if (hitResult == null) {
             return selfStack;
         }
-        if(hitResult instanceof HitResult.Tile hitTile) {
-            if(!world.canMineBlock(player, hitTile.tilePos)) {
+        if (hitResult instanceof HitResult.Tile hitTile) {
+            if (!world.canMineBlock(player, hitTile.tilePos)) {
                 return selfStack;
-            } else if(world.getBlockMaterial(hitTile.tilePos) == Material.water && world.getBlockData(hitTile.tilePos) == 0) {
-                if(useBucket(player, new ItemStack(Items.BUCKET_WATER))){
+            } else if (world.getBlockMaterial(hitTile.tilePos) == Materials.WATER && world.getBlockData(hitTile.tilePos) == 0) {
+                if (useBucket(player, new ItemStack(Items.BUCKET_WATER))) {
                     world.setBlockIdNotify(hitTile.tilePos, 0);
                     player.swingItem();
                 }
-            } else if(world.getBlockMaterial(hitTile.tilePos) == Material.lava && world.getBlockData(hitTile.tilePos) == 0) {
-                if(useBucket(player, new ItemStack(Items.BUCKET_LAVA))){
+            } else if (world.getBlockMaterial(hitTile.tilePos) == Materials.LAVA && world.getBlockData(hitTile.tilePos) == 0) {
+                if (useBucket(player, new ItemStack(Items.BUCKET_LAVA))) {
                     world.setBlockIdNotify(hitTile.tilePos, 0);
                     player.swingItem();
                 }
@@ -49,23 +51,23 @@ public class ItemBucketEmpty extends Item {
     }
 
     @Override
-    public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePos blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
+    public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
         if (selfStack.stackSize > 1) { // TODO figure out wtf to do for stacked buckets for this
             return;
         }
 
-        TilePos shiftedPos = blockPos.add(direction);
-        if(world.getBlockMaterial(shiftedPos) == Material.water && world.getBlockData(shiftedPos) == 0) {
+        TilePos shiftedPos = blockPos.add(direction, new TilePos());
+        if (world.getBlockMaterial(shiftedPos) == Materials.WATER && world.getBlockData(shiftedPos) == 0) {
             world.setBlockIdNotify(shiftedPos, 0);
             selfStack.itemID = Items.BUCKET_WATER.id;
             return;
-        } else if(world.getBlockMaterial(shiftedPos) == Material.lava && world.getBlockData(shiftedPos) == 0) {
+        } else if (world.getBlockMaterial(shiftedPos) == Materials.LAVA && world.getBlockData(shiftedPos) == 0) {
             world.setBlockIdNotify(shiftedPos, 0);
             selfStack.itemID = Items.BUCKET_LAVA.id;
             return;
         }
 
-        AABB box = AABB.fromPool(shiftedPos.x, shiftedPos.y, shiftedPos.z, shiftedPos.x + 1, shiftedPos.y + 1, shiftedPos.z + 1);
+        AABBdc box = new AABBd(shiftedPos.x, shiftedPos.y, shiftedPos.z, shiftedPos.x + 1, shiftedPos.y + 1, shiftedPos.z + 1);
         List<MobCow> entities = world.getEntitiesWithinAABB(MobCow.class, box);
         if (!entities.isEmpty()) {
             selfStack.itemID = Items.BUCKET_MILK.id;
@@ -74,15 +76,15 @@ public class ItemBucketEmpty extends Item {
 
     public static boolean useBucket(@NotNull Player player, @NotNull ItemStack itemToGive) {
         ItemStack currentItem = player.inventory.getCurrentItem();
-        if(currentItem == null || currentItem.stackSize <= 1) {
+        if (currentItem == null || currentItem.stackSize <= 1) {
             player.inventory.setItem(player.inventory.getCurrentItemIndex(), itemToGive);
             return true;
         } else {
-        	player.inventory.insertItem(itemToGive, true);
-        	if(itemToGive.stackSize < 1) {
-        		player.inventory.getCurrentItem().consumeItem(player);
-        		return true;
-        	}
+            player.inventory.insertItem(itemToGive, true);
+            if (itemToGive.stackSize < 1) {
+                player.inventory.getCurrentItem().consumeItem(player);
+                return true;
+            }
         }
         return false;
     }
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemDiscMusic.java b/game/core/src/main/java/net/minecraft/core/item/ItemDiscMusic.java
index ee9c0eb7f..40deff422 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemDiscMusic.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemDiscMusic.java
@@ -8,19 +8,18 @@ import net.minecraft.core.block.Blocks;
 import net.minecraft.core.world.LevelListener;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
-public class ItemDiscMusic extends Item
-{
+public class ItemDiscMusic extends Item {
     public final @Nullable String recordName;
     public final @Nullable String recordAuthor;
 
 
-    public ItemDiscMusic(@NotNull String name, @NotNull String namespaceId, int id, @Nullable String recordName, @Nullable String recordAuthor)
-    {
+    public ItemDiscMusic(@NotNull String name, @NotNull String namespaceId, int id, @Nullable String recordName, @Nullable String recordAuthor) {
         super(name, namespaceId, id);
         this.recordName = recordName;
         this.recordAuthor = recordAuthor;
@@ -28,8 +27,8 @@ public class ItemDiscMusic extends Item
     }
 
     @Override
-    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePos blockPos, @NotNull Side side, double xHit, double yHit) {
-        if(world.getBlockId(blockPos) == Blocks.JUKEBOX.id() && world.getBlockData(blockPos) == 0) {
+    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
+        if (world.getBlockId(blockPos) == Blocks.JUKEBOX.id() && world.getBlockData(blockPos) == 0) {
             if (!world.isClientSide) {
                 Blocks.JUKEBOX.getLogic().playRecord(world, new TilePos(blockPos), this.id);
                 world.playBlockEvent(null, blockPos, LevelListener.EVENT_JUKEBOX_TOGGLE, this.id);
@@ -41,8 +40,8 @@ public class ItemDiscMusic extends Item
     }
 
     @Override
-    public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePos blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
-        TilePos pos = blockPos.add(direction);
+    public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
+        TilePos pos = blockPos.add(direction, new TilePos());
         int b = world.getBlockId(pos);
         if (b == Blocks.JUKEBOX.id() && world.getBlockData(pos) == 0) {
             Blocks.JUKEBOX.getLogic().playRecord(world, new TilePos(pos), this.id);
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemDoor.java b/game/core/src/main/java/net/minecraft/core/item/ItemDoor.java
index 911d15585..5f273a557 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemDoor.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemDoor.java
@@ -12,120 +12,121 @@ import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 import java.util.Random;
 
 public class ItemDoor extends Item {
-	protected final @NotNull Block<? extends BlockLogicDoor> doorBlockBottom;
-	protected final @NotNull Block<? extends BlockLogicDoor> doorBlockTop;
+    protected final @NotNull Block<? extends BlockLogicDoor> doorBlockBottom;
+    protected final @NotNull Block<? extends BlockLogicDoor> doorBlockTop;
 
-	public ItemDoor(@NotNull String name, @NotNull String namespaceId, int id, @NotNull Block<? extends BlockLogicDoor> doorBlockBottom, @NotNull Block<? extends BlockLogicDoor> doorBlockTop) {
-		super(name, namespaceId, id);
+    public ItemDoor(@NotNull String name, @NotNull String namespaceId, int id, @NotNull Block<? extends BlockLogicDoor> doorBlockBottom, @NotNull Block<? extends BlockLogicDoor> doorBlockTop) {
+        super(name, namespaceId, id);
         this.maxStackSize = 64;
         this.doorBlockBottom = doorBlockBottom;
         this.doorBlockTop = doorBlockTop;
     }
 
-	@Override
-	public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePos blockPos, @NotNull Side side, double xHit, double yHit) {
-		if (player == null) return false;
-		if(!world.canPlaceInsideBlock(blockPos)) {
-			blockPos = blockPos.add(side.getDirection());
-		}
-
-		Direction leftDir = player.getHorizontalPlacementDirection(side).rotate(3);
-		int meta = leftDir.getHorizontalIndex();
-
-		int isSolidBlockLeft = (isSupported(world, blockPos, leftDir, false) ? 1 : 0) + (isSupported(world, blockPos.up(), leftDir, false) ? 1 : 0);
-		int isSolidBlockRight = (isSupported(world, blockPos, leftDir.getOpposite(), true) ? 1 : 0) + (isSupported(world, blockPos.up(), leftDir.getOpposite(), true) ? 1 : 0);
-		boolean isDoorLeft = world.getBlockId(blockPos.add(leftDir)) == this.doorBlockBottom.id() || world.getBlockId(blockPos.add(leftDir).up()) == this.doorBlockTop.id();
-		boolean isDoorRight = world.getBlockId(blockPos.sub(leftDir)) == this.doorBlockBottom.id() || world.getBlockId(blockPos.sub(leftDir).up()) == this.doorBlockTop.id();
-		boolean isMirrored = false;
-
-		if(isDoorLeft && !isDoorRight) {
-			isMirrored = (world.getBlockData(blockPos.add(leftDir)) & BlockLogicDoor.MASK_HINGE) == 0;
-		} else if (isSolidBlockLeft <= 0 || side.getDirection() != leftDir.getOpposite()) {
+    @Override
+    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
+        if (player == null) return false;
+        if (!world.canPlaceInsideBlock(blockPos)) {
+            blockPos = blockPos.add(side.getDirection(), new TilePos());
+        }
+
+        Direction leftDir = player.getHorizontalPlacementDirection(side).rotate(3);
+        int meta = leftDir.getHorizontalIndex();
+
+        int isSolidBlockLeft = (isSupported(world, blockPos, leftDir, false) ? 1 : 0) + (isSupported(world, blockPos.up(new TilePos()), leftDir, false) ? 1 : 0);
+        int isSolidBlockRight = (isSupported(world, blockPos, leftDir.getOpposite(), true) ? 1 : 0) + (isSupported(world, blockPos.up(new TilePos()), leftDir.getOpposite(), true) ? 1 : 0);
+        boolean isDoorLeft = world.getBlockId(blockPos.add(leftDir, new TilePos())) == this.doorBlockBottom.id() || world.getBlockId(blockPos.add(leftDir, new TilePos()).up(new TilePos())) == this.doorBlockTop.id();
+        boolean isDoorRight = world.getBlockId(blockPos.sub(leftDir, new TilePos())) == this.doorBlockBottom.id() || world.getBlockId(blockPos.sub(leftDir, new TilePos()).up(new TilePos())) == this.doorBlockTop.id();
+        boolean isMirrored = false;
+
+        if (isDoorLeft && !isDoorRight) {
+            isMirrored = (world.getBlockData(blockPos.add(leftDir, new TilePos())) & BlockLogicDoor.MASK_HINGE) == 0;
+        } else if (isSolidBlockLeft <= 0 || side.getDirection() != leftDir.getOpposite()) {
             if (isSolidBlockRight > 0 && side.getDirection() == leftDir) {
                 isMirrored = true;
             } else if (isSolidBlockRight > isSolidBlockLeft) {
                 isMirrored = true;
             }
         }
-        if(isMirrored) {
-			meta = meta - 1 & 0b11;
-			meta |= 0b100;
-			meta |= 0b1000;
-		}
-		meta |= (DyeColor.colorFromItemMeta(selfStack.getMetadata()).blockMeta) << 4 & 0xF0;
-
-		if(!this.doorBlockBottom.getLogic().canPlaceAt(world, blockPos, meta)) {
-			return false;
-		}
-
-		world.noNeighborUpdate = true;
-		world.setBlockIdDataNotify(blockPos, this.doorBlockBottom.id(), meta);
-		world.setBlockIdDataNotify(blockPos.up(), this.doorBlockTop.id(), meta);
-		world.noNeighborUpdate = false;
-		world.notifyBlocksOfNeighborChange(blockPos, this.doorBlockBottom.id());
-		world.notifyBlocksOfNeighborChange(blockPos.up(), this.doorBlockTop.id());
-		world.playBlockSoundEffect(player, blockPos.x + 0.5F, blockPos.y + 0.5F, blockPos.z + 0.5F, this.doorBlockBottom, EnumBlockSoundEffectType.PLACE);
+        if (isMirrored) {
+            meta = meta - 1 & 0b11;
+            meta |= 0b100;
+            meta |= 0b1000;
+        }
+        meta |= (DyeColor.colorFromItemMeta(selfStack.getMetadata()).blockMeta) << 4 & 0xF0;
+
+        if (!this.doorBlockBottom.getLogic().canPlaceAt(world, blockPos, meta)) {
+            return false;
+        }
+
+        world.noNeighborUpdate = true;
+        world.setBlockIdDataNotify(blockPos, this.doorBlockBottom.id(), meta);
+        world.setBlockIdDataNotify(blockPos.up(new TilePos()), this.doorBlockTop.id(), meta);
+        world.noNeighborUpdate = false;
+        world.notifyBlocksOfNeighborChange(blockPos, this.doorBlockBottom.id());
+        world.notifyBlocksOfNeighborChange(blockPos.up(new TilePos()), this.doorBlockTop.id());
+        world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, this.doorBlockBottom, EnumBlockSoundEffectType.PLACE);
         this.doorBlockBottom.onPlacedByMob(world, blockPos, side, player, xHit, yHit);
-        this.doorBlockTop.onPlacedByMob(world, blockPos.up(), side, player, xHit, yHit);
-		selfStack.consumeItem(player);
-		return true;
-	}
-
-	public boolean isSupported(@NotNull World world, @NotNull TilePos tilePos, @NotNull Direction direction, boolean mirrored) {
-		ISupport support = world.getSupport(tilePos.add(direction), direction.getSide().getOpposite());
-		return support.canSupport(mirrored ? PartialSupport.INSTANCE.right() : PartialSupport.INSTANCE.left(), direction.getSide());
-	}
-
-	@Override
-	public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePos blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
-		if(!world.canPlaceInsideBlock(blockPos)) {
-			blockPos = blockPos.add(direction);
-		}
-
-		if (!direction.isHorizontal()) direction = Direction.NORTH;
-		Direction lefDir = direction.rotate(3);
-		int meta = lefDir.getHorizontalIndex();
-
-		int isSolidBlockLeft = (isSupported(world, blockPos, lefDir, false) ? 1 : 0) + (isSupported(world, blockPos.up(), lefDir, false) ? 1 : 0);
-		int isSolidBlockRight = (isSupported(world, blockPos, lefDir.getOpposite(), true) ? 1 : 0) + (isSupported(world, blockPos.up(), lefDir.getOpposite(), true) ? 1 : 0);
-		boolean isDoorLeft = world.getBlockId(blockPos.add(lefDir)) == this.doorBlockBottom.id() || world.getBlockId(blockPos.add(lefDir).up()) == this.doorBlockTop.id();
-		boolean isDoorRight = world.getBlockId(blockPos.sub(lefDir)) == this.doorBlockBottom.id() || world.getBlockId(blockPos.sub(lefDir).up()) == this.doorBlockTop.id();
-		boolean isMirrored = false;
-
-		if(isDoorLeft && !isDoorRight) {
-			isMirrored = (world.getBlockData(blockPos.add(lefDir)) & BlockLogicDoor.MASK_HINGE) == 0;
-		} else if (isSolidBlockLeft <= 0 || direction != lefDir.getOpposite()) {
+        this.doorBlockTop.onPlacedByMob(world, blockPos.up(new TilePos()), side, player, xHit, yHit);
+        selfStack.consumeItem(player);
+        return true;
+    }
+
+    public boolean isSupported(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Direction direction, boolean mirrored) {
+        ISupport support = world.getSupport(tilePos.add(direction, new TilePos()), direction.getSide().getOpposite());
+        return support.canSupport(mirrored ? PartialSupport.INSTANCE.right() : PartialSupport.INSTANCE.left(), direction.getSide());
+    }
+
+    @Override
+    public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
+        if (!world.canPlaceInsideBlock(blockPos)) {
+            blockPos = blockPos.add(direction, new TilePos());
+        }
+
+        if (!direction.isHorizontal()) direction = Direction.NORTH;
+        Direction lefDir = direction.rotate(3);
+        int meta = lefDir.getHorizontalIndex();
+
+        int isSolidBlockLeft = (isSupported(world, blockPos, lefDir, false) ? 1 : 0) + (isSupported(world, blockPos.up(new TilePos()), lefDir, false) ? 1 : 0);
+        int isSolidBlockRight = (isSupported(world, blockPos, lefDir.getOpposite(), true) ? 1 : 0) + (isSupported(world, blockPos.up(new TilePos()), lefDir.getOpposite(), true) ? 1 : 0);
+        boolean isDoorLeft = world.getBlockId(blockPos.add(lefDir, new TilePos())) == this.doorBlockBottom.id() || world.getBlockId(blockPos.add(lefDir, new TilePos()).up(new TilePos())) == this.doorBlockTop.id();
+        boolean isDoorRight = world.getBlockId(blockPos.sub(lefDir, new TilePos())) == this.doorBlockBottom.id() || world.getBlockId(blockPos.sub(lefDir, new TilePos()).up(new TilePos())) == this.doorBlockTop.id();
+        boolean isMirrored = false;
+
+        if (isDoorLeft && !isDoorRight) {
+            isMirrored = (world.getBlockData(blockPos.add(lefDir, new TilePos())) & BlockLogicDoor.MASK_HINGE) == 0;
+        } else if (isSolidBlockLeft <= 0 || direction != lefDir.getOpposite()) {
             if (isSolidBlockRight > 0 && direction == lefDir) {
                 isMirrored = true;
             } else if (isSolidBlockRight > isSolidBlockLeft) {
                 isMirrored = true;
             }
         }
-        if(isMirrored) {
-			meta = meta - 1 & 0b11;
-			meta |= 0b100;
-			meta |= 0b1000;
-		}
-		meta |= (DyeColor.colorFromItemMeta(selfStack.getMetadata()).blockMeta) << 4 & 0xF0;
-		if(!this.doorBlockBottom.getLogic().canPlaceAt(world, blockPos, meta)) {
-			return;
-		}
-
-		world.noNeighborUpdate = true;
-		world.setBlockIdDataNotify(blockPos, this.doorBlockBottom.id(), meta);
-		world.setBlockIdDataNotify(blockPos.up(), this.doorBlockTop.id(), meta);
-		world.noNeighborUpdate = false;
-		world.notifyBlocksOfNeighborChange(blockPos, this.doorBlockBottom.id());
-		world.notifyBlocksOfNeighborChange(blockPos.up(), this.doorBlockTop.id());
-		world.playBlockSoundEffect(null, blockPos.x + 0.5F, blockPos.y + 0.5F, blockPos.z + 0.5F, this.doorBlockBottom, EnumBlockSoundEffectType.PLACE);
+        if (isMirrored) {
+            meta = meta - 1 & 0b11;
+            meta |= 0b100;
+            meta |= 0b1000;
+        }
+        meta |= (DyeColor.colorFromItemMeta(selfStack.getMetadata()).blockMeta) << 4 & 0xF0;
+        if (!this.doorBlockBottom.getLogic().canPlaceAt(world, blockPos, meta)) {
+            return;
+        }
+
+        world.noNeighborUpdate = true;
+        world.setBlockIdDataNotify(blockPos, this.doorBlockBottom.id(), meta);
+        world.setBlockIdDataNotify(blockPos.up(new TilePos()), this.doorBlockTop.id(), meta);
+        world.noNeighborUpdate = false;
+        world.notifyBlocksOfNeighborChange(blockPos, this.doorBlockBottom.id());
+        world.notifyBlocksOfNeighborChange(blockPos.up(new TilePos()), this.doorBlockTop.id());
+        world.playBlockSoundEffect(null, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, this.doorBlockBottom, EnumBlockSoundEffectType.PLACE);
         this.doorBlockBottom.onPlacedOnSide(world, blockPos, direction.getSide(), 0.5, 0.5);
-        this.doorBlockTop.onPlacedOnSide(world, blockPos.up(), direction.getSide(), 0.5, 0.5);
-		selfStack.consumeItem(null);
-	}
+        this.doorBlockTop.onPlacedOnSide(world, blockPos.up(new TilePos()), direction.getSide(), 0.5, 0.5);
+        selfStack.consumeItem(null);
+    }
 }
